<?php
/*
Plugin Name: Direct Register WPMU
Plugin URI:
Description: Lets Your MU child blog reader to register directly to the child blog. It adds a new widget which shows a link to child blog register page.
Version: 1.1
Author: Shinichi Nishikawa
Author URI: http://nobil.co/
*/


/*****************************************
-------  メタ情報ウィジェットカスタマイズ --------
******************************************/

class Colog_Meta extends WP_Widget {

	function __construct() {
		$widget_ops = array('classname' => 'widget_meta', 'description' => "ログイン/ログアウト、管理画面へのリンクを表示します。" );
		parent::__construct('meta', '管理メニュー', $widget_ops);
	}

	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '管理メニュー' : $instance['title'], $instance, $this->id_base);

		echo $before_widget;
		if ( $title )
			echo $before_title . $title . $after_title;
?>
			<ul>
			<?php if( is_user_logged_in() ) { ?>
				<li><a href="<?php echo get_admin_url() ?>">管理画面</a></li>
			<?php } ?>
			<li><?php wp_loginout(); ?></li>				
			<?php if ( !is_user_logged_in() ) {
	      		global $current_blog;
	      		$from_blog_id = $current_blog->blog_id; 
	      		?>
				<li><a href="<?php echo esc_attr(network_home_url('wp-signup.php?from_blog_id=')).$from_blog_id; ?>">「<?php bloginfo('name') ?>」に<br />読者申請する</a></li>
				<?php 
					if ( get_option('users_can_register') ) { ?>
						<li><a href="<?php echo esc_attr(network_home_url('wp-signup.php')); ?>">新しいブログを作る</a></li>
				<?php
					}
			 } ?>
<!--
			<li><a href="<?php bloginfo('rss2_url'); ?>" title="<?php echo esc_attr(__('Syndicate this site using RSS 2.0')); ?>"><?php _e('Entries <abbr title="Really Simple Syndication">RSS</abbr>'); ?></a></li>
			<li><a href="<?php bloginfo('comments_rss2_url'); ?>" title="<?php echo esc_attr(__('The latest comments to all posts in RSS')); ?>"><?php _e('Comments <abbr title="Really Simple Syndication">RSS</abbr>'); ?></a></li>
			<li><a href="http://wordpress.org/" title="<?php echo esc_attr(__('Powered by WordPress, state-of-the-art semantic personal publishing platform.')); ?>">WordPress.org</a></li>
-->
			<?php wp_meta(); ?>
			</ul>
<?php
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => '' ) );
		$title = strip_tags($instance['title']);
?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("Colog_Meta");'));


/*****************************************
------- 読者登録の場合には、
		  ブログ／読者選択肢を表示しない --------
******************************************/
function dr_active_signup_changer() {
	$from_blog_id = isset( $_GET['from_blog_id'] ) ? $_GET['from_blog_id'] : '1';
	$from_blog_id = intval($from_blog_id);
	if ( $from_blog_id == 0 ) {
		die('変なことしてませんか？');
	}
	echo '<input type="hidden" name="from_blog_id" value="'.$from_blog_id.'" />';
	$from_blog_name = get_blog_option($from_blog_id, 'blogname');
	global $active_signup;
	if ( $from_blog_id == '1' ) {
		$active_signup = 'blog';
	} else {
		echo '<h1>'.$from_blog_name.'に読者申請をする</h1>';
		$active_signup = 'user';		
	}
}
add_action('signup_hidden_fields','dr_active_signup_changer');


/*****************************************
------- 子ブログに直接登録する --------
******************************************/
function dr_add_blog_id_to_meta() {
	$secure_id = intval($_POST['from_blog_id']);
	if ( $secure_id == 0 ) {
		die('何かが変です。。');
	} else {
		$meta = array(
		"add_to_blog" => $secure_id,
		"new_role" => 'Subscriber'
		);
		return $meta;
	}
}
add_filter("add_signup_meta","dr_add_blog_id_to_meta");

?>
